

CREATE AutoComplForm AS QFORM
    Width = 300
    Height = 120
    BorderStyle = bsToolWindow
    KeyPreview = True
    OnKeyPress = AutoComplList_Enter

    CREATE AutoComplList AS QLISTBOX
        Font.Size = 12
        'Color = IDE.BackGround
        ItemHeight = 28
        Width = AutoComplForm.ClientWidth
        Height = AutoComplForm.ClientHeight
        OnDblClick = AutoComplList_Selected     'onClick is triggered by cursor down
        'OnEnter = AutoComplList_Enter
    END CREATE
END CREATE


SUB IDE_AutoCompleteWord
    IF IDE.KeyWordList.ItemCount = 0 THEN  EXIT SUB                                'if list0 is empty then others should be too

    DEFSTR s = IDE_GetKeywordFromText(re.WordLeftOfCursor(), "_-+(." + Quot$ + sQuot + Comma)    'Autocomplete- ignore leading "(,-+" etc.
    DEFINT L = LEN(s)

    IF INSTR(s, ".") > 0 THEN s = RIGHT$(s, L - INSTR(s, ".")):   L = LEN(s)    'allow for completing properties
    DEFINT TheCase = ASC(RIGHT$(s , 1))                                         'keep track of the case
    s = LCASE$(s)                                                               'autocomplete keword search must be lower case

'   re.SendEditor(SCI_AUTOCSHOW, LEN(s), IDE.KeyWordList.Text)                  'no joy...

    DIM lookupList AS QSTRINGLIST
        'RQinFB pre compiler commands
        lookupList.AddItems("pre cmd", "killfiles", "kill", "run", "nobeep" "nocon", "adddll", "noadddll" , "diricon", "upx")
        lookupList.AddList IDE.KeyWordList
        lookupList.AddList IDE.KeyWordList2
        lookupList.AddList IDE.KeyWordList3
        'lookupList.Sorted = True           'keep in priority order

    AutoComplList.Clear

    'generate matches
    DEFINT i = 0
    FOR i = 0 TO lookupList.ItemCount - 1
        IF s = LEFT$(lookupList.Item(i), L)  THEN AutoComplList.AddItems(lookupList.Item(i))
        'IF INSTR(lookupList.Item(i) , s) THEN AutoComplList.AddItems(lookupList.Item(i))       'bad idea
    NEXT i

    lookupList.Clear                                                                'dealloc
    IF AutoComplList.ItemCount = 0 THEN EXIT SUB                                    'no match, nothing close 

    'insert into text if only one match otherwise show the autocomplete form
    IF AutoComplList.ItemCount = 1 THEN                                             'just one match
        IF re.SelText <> "" THEN re.Set_AnchorPosition(re.Position + L)
        'here we match the case of the keyword
        IF (TheCase > 64) AND (TheCase < 91) THEN                                   'upper case
            re.AddStrings(UCASE$(RIGHT$(AutoComplList.Item(0), LEN(AutoComplList.Item(0)) - L)))
            re.SetFocus
        ELSE
            re.AddStrings(RIGHT$(AutoComplList.Item(0), LEN(AutoComplList.Item(0)) - L))
            re.SetFocus
        END IF

    ELSE

        AutoComplList.ItemIndex = 0
        i = (AutoComplList.ItemCount + 1) * AutoComplList.ItemHeight + 24            'get how high the widget will be
        IF i > 480 THEN i = 480                     'limit it to 500 pixels
        AutoComplForm.Height = i
        AutoComplList.Height = AutoComplForm.ClientHeight
        AutoComplForm.Left = Screen.MouseX
        IF AutoComplForm.Left > (Screen.Width - AutoComplForm.Width) THEN AutoComplForm.Left = Screen.Width - AutoComplForm.Width
        AutoComplForm.Top = Screen.MouseY
        IF AutoComplForm.Top > (Screen.Height - AutoComplForm.Height - 48) THEN AutoComplForm.Top = Screen.Height - AutoComplForm.Height -48
        AutoComplForm.Show
    END IF

END SUB



SUB AutoComplList_Enter(Key AS BYTE)
    IF Key = 13 THEN AutoComplList_Selected
    IF Key = 27 THEN 
        AutoComplForm.Close
        re.SetFocus
    END IF
END SUB


SUB AutoComplList_Selected

    'this is redundant but less globals...
    DEFSTR s = IDE_GetKeywordFromText(re.WordLeftOfCursor(), "_-+(." + Quot$ + sQuot + Comma)    'Autocomplete- ignore leading "(,-+" etc.
    DEFINT L = LEN(s)
    DEFINT TheCase = ASC(RIGHT$(s , 1))                                         'keep track of the case
    s = AutoComplList.Item(AutoComplList.ItemIndex)

    IF re.SelText <> "" THEN re.Set_AnchorPosition(re.Position + L)
    IF (TheCase > 64) AND (TheCase < 91) THEN                                   'upper case
        re.AddStrings(UCASE$(RIGHT$(s, LEN(s) -L)))
    ELSE
        re.AddStrings(RIGHT$(s, LEN(s) -L))
    END IF
    AutoComplForm.Close
    re.SetFocus
END SUB


